#include <iostream>
#include "heuristic.h"

using namespace std;

void bubbleSort(float *koefs, int *indexes, int n);
void innerSolve(State &best);

State heuristicRate(void) {
		State best = {0,0,0};
		innerSolve(best);
		return best;
}

State heuristicTest(void) {
		State best = {0,0,0};
		innerSolve(best);

		int price = 0;
		for(int i = instanceSize-1; i >= 0; i--) {
				if(itemCosts[i] > best.cost) {
						best.value = getLongLong(i);
						best.cost = itemCosts[i];
						best.weight = itemWeights[i];
				}
		}

		return best;
}

void innerSolve(State &best) {
		float *koefs = new float[instanceSize];
		for(int i = instanceSize-1; i >= 0; i--) {
				koefs[i] = (float) itemCosts[i] / (float) itemWeights[i];
		}

		int *indexes = new int[instanceSize];
		for(int i = instanceSize-1; i >= 0; i--) {
				indexes[i] = i;
		}

		bubbleSort(koefs, indexes, instanceSize);
		
		delete [] koefs;

		int weight = 0;
		int i = 0;

		while((best.weight != maxAllowedWeight) && (i < instanceSize)) {
				if((best.weight + itemWeights[indexes[i]]) <= maxAllowedWeight) {
						best.value |= getLongLong(indexes[i]);
						best.cost += itemCosts[indexes[i]];
						best.weight += itemWeights[indexes[i]];
				}
				i++;
		}

		delete [] indexes;
}

void bubbleSort(float *koefs, int *indexes, int n) {
		int i, j, temp, flag;

		for(i = n-1; i > 0; i--) {
				flag = 1;
				for(j = 0; i > j; j++) {
						if(koefs[indexes[j]] < koefs[indexes[j+1]]){
								flag = 0;
								temp = indexes[j];
								indexes[j] = indexes[j+1];
								indexes[j+1] = temp;
						}
				}
				if(flag) break;
		}
}
